#!/usr/bin/perl5

require "openfaq.pl";

if ($request =~ /^\/applysubmit$/) {
	&applySubmit;
} else {
	&apply;
}

sub apply
{
	print <<EOM
	<h1>Application to Write Articles</h1>
	You must provide your email address. When you do, you 
	will be <strong>emailed a password</strong> which you
	will use when adding or updating articles. This is done
	in order to provide the OpenFAQ with a modest degree of
	credibility, cutting down greatly on spam and other
	abuses of this free service. <strong>If you do not wish 
	to provide your email address, you will not be able to 
	participate.  Sorry for any inconvenience.</strong>
	<p>
	<strong>
	ALL MATERIALS ARE REVIEWED BY THE MODERATOR BEFORE
	THEY APPEAR TO THE PUBLIC. IF YOU ARE ABOUT TO SPAM,
	DON'T BOTHER.
	<p>
	THE MAINTAINER HAS THE FINAL SAY IN ACCEPTING AND/OR
	EDITING ARTICLES. IF YOU DO NOT LIKE THE MAINTAINER'S
	POLICIES, SET UP YOUR OWN OPENFAQ.
	<p>
	ALL MATERIALS YOU SUBMIT ARE COVERED BY THE GNU
	PUBLIC LICENSE. IF YOU DO NOT WISH TO MAKE YOUR
	CONTRIBUTIONS FREELY REPRODUCIBLE BY ALL, WITHOUT FEE,
	OR YOU DO NOT OWN THE COPYRIGHT ON YOUR MATERIALS,
	DO NOT SUBMIT THEM. FILLING OUT THIS APPLICATION
	SIGNIFIES ACCEPTANCE OF THESE TERMS.
	</strong>
	<p>
	Please provide your email address and the name your 
	articles should be attributed to at this time. 
	Names should not contain spaces or other non-alpha
	characters (letters, underscores and digits are OK).
	<p>
	<form action="$url/apply.cgi/applysubmit" method=POST>
	<input name="name">Your Name (NO SPACES!)<br>
	<input name="email">Your Email Address<br>
	<input type=submit value="Apply Now">
	</form>
EOM
;
}

sub applySubmit
{
	my($name, $email);	
	$name = $input{"name"};
	$email = $input{"email"};
	$name =~ s/[^\w]//g;
	$email =~ s/[^\w|0-9|_|-|@|\!|\.]//g;
	if (($name eq "") || ($email eq "")) {
		print <<EOM
<h1>Please Fill Out Both Fields</h1>
You must provide both a name and an email
address. The name field should contain only
letters, digits and underscores. The email
address field should contain only characters
which are legitimate in an email address.
<hr>
EOM
;
		&apply;
		return;
	}	
	# Root through the password file and make sure it's
	# a unique name
	open(IN, "<" . $passwordFile);
	my($line);
	while ($line = <IN>) {
		chomp $line;
		my($ename, $epwd) = split(/:/, $line);
		if ($ename eq "") {
			next;
		}
		if ($ename eq $name) {
			print "<strong>I'm sorry, that name is ",
				"already taken. Choose another.</strong><hr>\n";
			close(IN);
			&apply;
			return;
		}
	}
	close(IN);
	# Invent a password
	my($password);
	for ($i = 0; ($i < 6); $i++) {
		$password .= sprintf("%c", int(rand(26)) + ord("a"));
        }
	&writePassword($name, $password);
	&writeEmail($name, $email);
	open(OUT, "|" . $sendmail . " -t");
	print OUT <<EOM
To: $email
Subject: OpenFAQ Password!

The following is your username and password for use with the 	
$topic. PLEASE KEEP THIS MESSAGE.

USERNAME: $name
PASSWORD: $password

HOW TO LOG IN:

Access $url with your web browser.

IF YOU HAVE QUESTIONS:

You can reach the maintainer, $maintainer, at the
following email address: $maintainerEmail
EOM
;
	print <<EOM
<h1>Accepted</h1>
Your application has been processed, and a
password has been emailed to you. The email
contains complete instructions for logging
into the system in order to add and update
articles in the OpenFAQ. Thank you very much
for your participation in this volunteer effort!
EOM
;
}

sub writePassword
{
	my($name, $pwd) = @_;
	open(IN, "<" . $passwordFile);
	open(OUT, ">" . $passwordFile . ".temp");
	my($line, $found);
	while ($line = <IN>) {
		chomp $line;
		my($ename, $epwd) = split(/:/, $line);
		if ($ename eq "") {
			next;
		}
		if ($ename eq $name) {
			print OUT "$name:", &pwd($pwd), "\n";
			$found = 1;
		} else {
			print OUT "$ename:$epwd\n";
		}
	}		
	if (!$found) {
		print OUT "$name:", &pwd($pwd), "\n";
	}
	close(IN);
	close(OUT);
	open(IN, "<" . $passwordFile . ".temp");
	open(OUT, ">" . $passwordFile);
	while ($line = <IN>) {
		print OUT $line;
	}	
	close(IN);
	close(OUT);
}

sub writeEmail
{
	my($name, $email) = @_;
	open(IN, "<" . $emailAddressesFile);
	open(OUT, ">" . $emailAddressesFile . ".temp");
	my($line, $found);
	while ($line = <IN>) {
		chomp $line;
		my($ename, $eemail) = split(/:/, $line);
		if ($ename eq "") {
			next;
		}
		if ($ename eq $name) {
			print OUT "$name\t$email\n";
			$found = 1;
		} else {
			print OUT "$ename\t$eemail\n";
		}
	}		
	if (!$found) {
		print OUT "$name\t$email\n";
	}
	close(IN);
	close(OUT);
	open(IN, "<" . $emailAddressesFile . ".temp");
	open(OUT, ">" . $emailAddressesFile);
	while ($line = <IN>) {
		print OUT $line;
	}	
	close(IN);
	close(OUT);
}

sub pwd
{
	my($arg) = @_;
	return crypt($arg,
		pack("CC", 
		ord('a') + rand(26), 
		ord('a') + rand(26)));
}

