#!/usr/bin/perl5

require "../openfaq.pl";

&checkMaintainer;

$id = $input{"id"};

$request = $ENV{"PATH_INFO"};

if ($request =~ /^\/update$/) {
	&update($id);
} elsif ($request =~ /^\/add$/) {
	&add($id);
} elsif ($request =~ /^\/remove$/) {
	&remove($id);
}elsif ($request =~ /^\/action$/) {
	&action($id);
} else {
	&index;
}

sub index
{
	opendir(DIN, ".");
	@allfiles = grep !/^\.\.?$/, readdir DIN;
	closedir(DIN);

	print "Select an update or remove request to review and possibly ",
		"accept it.<p>\n";

	print "<ul>\n";
	for $f (@allfiles)
	{
		if ($f =~ /^(\d+)\.update$/) {
			$id = $1;
			&readEntry($id, 1);
			if ($entry =~ /REMOVE REMOVE REMOVE/) {
				print "<li><a href=\"$url/authors/admin.cgi/remove?id=$id\">REMOVE $id, Subject: $subject</a>\n";
			} elsif (int(@by) > 1) { 
				print "<li><a href=\"$url/authors/admin.cgi/update?id=$id\">UPDATE $id, Subject: $subject</a>\n";
			} else {
				print "<li><a href=\"$url/authors/admin.cgi/add?id=$id\">ADD $id, Subject: $subject</a>\n";
			}
		}
	}
	print "</ul>\n";
	print "None of the changes you make through this interface appear ",
		"in the public document until you use the link below.\n<p>";
	print "<form action=\"$url/authors/publish.cgi\" method=POST>",
		"<input type=submit value=PUBLISH></form>\n";
}

sub remove
{
	&readEntry($id, 1);
	$perp = $by[$#by];
	&readEntry($id, 0);
	print "$perp wants to remove the following article:<p>\n";
	print "<strong>Subject: </strong>", &htmlEscape($subject), "<p>\n";
	print $entry;
	print "<hr>\n";
	print "<form action=\"$url/authors/admin.cgi/action\" method=POST>\n";
	print "<input type=hidden value=$id name=id>\n";
	print "<input type=submit value=Confirm name=confirm>\n";
	print "<input type=submit value=Reject name=reject><p>\n";
	print "Your comments to author (leave blank if none):<br>\n";
	print "<textarea name=comments rows=5 cols=60></textarea><p>\n";
	print "</form>\n";
	&footer;
}

sub update
{
	&readEntry($id, 1);
	$perp = $by[$#by];
	&readEntry($id, 0);
	print "$perp wants to update the following article:<p>\n";
	print "CURRENT VERSION (do NOT edit these fields):<p>\n";
	print "<form action=\"$url/authors/admin.cgi/action\" method=POST>\n";
	print "<input name=oldsubject value=\"", &htmlEscape($subject), 
		"\"> Subject<br>\n";
	print "<textarea name=oldentry rows=5 cols=60>", &htmlEscape($entry),
		"</textarea><p>\n";
	&readEntry($id, 1);
	print "<hr>\n";
	print "REVISED VERSION (you CAN edit these fields):<p>\n";
	print "<input name=subject value=\"", &htmlEscape($subject), 
		"\"> Subject<br>\n";
	print "<textarea name=entry rows=5 cols=60>", &htmlEscape($entry),
		"</textarea><p>\n";
	print "<hr>\n";
	print "<input type=hidden value=$id name=id>\n";
	print "<input type=submit value=Confirm name=confirm>\n";
	print "<input type=submit value=Reject name=reject><p>\n";
	print "Your comments to author (leave blank if none):<br>\n";
	print "<textarea name=comments rows=5 cols=60></textarea><p>\n";
	print "</form>\n";
	&footer;
}

sub add
{
	&readEntry($id, 1);
	$perp = $by[$#by];
	print "$perp wants to add the following article:<p>\n";
	print "<hr>\n";
	print "<form action=\"$url/authors/admin.cgi/action\" method=POST>\n";
	print "<input name=subject value=\"", &htmlEscape($subject), 
		"\"> Subject<br>\n";
	print "<textarea name=entry rows=5 cols=60>", &htmlEscape($entry),
		"</textarea><p>\n";
	print "<hr>\n";
	print "<input type=hidden value=$id name=id>\n";
	print "<input type=submit value=Confirm name=confirm>\n";
	print "<input type=submit value=Reject name=reject><p>\n";
	print "Your comments to author (leave blank if none):<br>\n";
	print "<textarea name=comments rows=5 cols=60></textarea><p>\n";
	print "</form>\n";
	&footer;
}

sub footer
{
	print "<a href=\"$url/authors/admin.cgi\">To Admin Page</a> | ",
		"<a href=\"$url\">To Table of Contents</a>\n";
}

sub startMail
{
	open(OUT, "|" . $sendmail . " -t");
	print OUT "To: ", $email[$#email], "\n";
	print OUT "Subject: ", $topic, "\n";
	print OUT "\n";
}

sub comments
{
	if ($input{"comments"} ne "") {
		print OUT "\nThe maintainer sends the following comment:\n\n";
		print OUT $input{"comments"}, "\n";
	}
}

sub action
{
	if (defined($input{"confirm"})) {
		&readEntry($id, 1);
		if ($entry =~ /REMOVE REMOVE REMOVE/) {
			unlink($id);		
			unlink($id . ".update");
			print "<h2>Removed.</h2>\n";
			&startMail;
			print OUT "The article $subject was removed, ",
				"per your request.\n";
			&comments;
			close(OUT);  
		} else {
			unlink($id . ".update");
			$subject = $input{"subject"};
			$entry = $input{"entry"};
			&writeEntry($id, 0);
			if (int(@by) == 1) {
				&startMail;
				print OUT "The article $subject was added, ",
					"per your request.\n";
				&comments;
				close(OUT);
				print "<h2>Added.</h2>\n";
			} else {
				&startMail;
				print OUT "The article $subject was updated, ",
					"per your request.\n";
				&comments;
				close(OUT);
				print "<h2>Updated.</h2>\n";
			}
		}
	} else {
		unlink($id . ".update");
		print "<h2>Request rejected.</h2>\n";
		&startMail;
		print OUT "Your request regarding the article $subject ",
			"was rejected by the maintainer.\n";
		&comments;
		close(OUT);
	}
	# Cachebusting: pass some extra crud in the footer
	print "<a href=\"$url/authors/admin.cgi?dummy=", int(rand() * 50000), 
		"\">To Admin Page</a> | ",
		"<a href=\"$url\">To Table of Contents</a>\n";
}

