#!/usr/bin/perl5

require "../openfaq.pl";

$id = $input{"id"};
$id = int($id);

if (defined($input{"add"})) {
	&add;
} elsif ($request =~ /^\/addsubmit$/) {
	&addSubmit;
} elsif (defined($input{"remove"})) {
	&remove;
} elsif ($request =~ /^\/removesubmit$/) {
	&removeSubmit;
} elsif (defined($input{"update"})) {
	&update;
} elsif ($request =~ /^\/updatesubmit$/) {
	&updateSubmit;
} elsif ($request =~ /^\/updateconfirm$/) {
	&updateConfirm;
}
&menu;
&copyright;

sub menu
{
	print "<hr>\n";
	print "<h4><a href=\"" . $url . "\">Index</a></h4>\n";
}

sub copyright
{
	print <<EOM
<hr>
<strong>ALL ARTICLES SUBMITTED ARE SUBJECT TO THE TERMS OF THE
GNU PUBLIC LICENSE, WHICH PERMITS FREE REPRODUCTION. IF YOU 
DO NOT OWN THE COPYRIGHT ON THE MATERIALS YOU ARE SUBMITTING, DO NOT 
SUBMIT THEM. OTHER AUTHORS ARE PERMITTED TO REVISE AND/OR REMOVE
YOUR ARTICLE AT THE DISCRETION OF THE MODERATOR! Compilation copyright 
1997 by $maintainer. All individual articles copyright 1997 by their 
respective authors. 
EOM
;
}

sub add
{
	print "<h2>Add an OpenFAQ Entry</h2>\n";
	print "Are you sure you don't want to <strong>update another ",
		"entry instead of adding a new one?</strong> Your entry ",
		"may be rejected if it is redundant.<p>\n";
	&addBlurb;
print <<EOM
	<p>	
	<form action="$url/authors/edit.cgi/addsubmit" method=POST>	
	<input name="subject" size="40"> Subject<p>
	HTML Text: <br>
	<textarea rows="10" cols="60" name="entry">
	</textarea>
	<p>
	<input type="submit" value="Submit Entry"><input type="reset">
	</form>
EOM
;
}

sub remove
{
	if ($input{"id"} eq "") {
		print "<h2>Select an article to remove first.</h2>\n";
		return;
	}
	&readEntry($id, 0);
	if (open(IN, $id . ".update")) {
		close(IN);
		print "<h2>Update Already Submitted</h2>\n";
		print "An update has already been submitted for this subject.\n";
		print "To avoid problems in reconciling updates, the\n";
		print "openfaq system only accepts one update at a time.\n";
		print "It will be possible to update this subject again\n";
		print "as soon as the outstanding update request has been\n";
		print "processed by the maintainer. Since openfaq\n";
		print "maintainers are volunteers, this may take time.\n";
		print "Thanks for your patience!\n";
		return;
	}
	print "<h2>Remove an OpenFAQ Entry</h2>\n";
print <<EOM
	<strong>NOTE:</strong> your removal request will be reviewed by the 
	maintainer before it takes effect. Please review the article to
	make sure you want to remove it.
	<p>
	<form action="$url/authors/edit.cgi/removesubmit" method=POST>	
	<input name="id" type="hidden" value="$id">
	<strong>Subject: </strong> $subject<br>
	Text: $entry
	<p>
	<input type="submit" value="Remove Entry">
	</form>
EOM
;
}

sub update
{
	if ($input{"id"} eq "") {
		print "<h2>Select an article to update first.</h2>\n";
		return;
	}
	&readEntry($id, 0);
	if (open(IN, $id . ".update")) {
		close(IN);
		print "<h2>Update Already Submitted</h2>\n";
		print "An update has already been submitted for this subject.\n";
		print "To avoid problems in reconciling updates, the\n";
		print "openfaq system only accepts one update at a time.\n";
		print "It will be possible to update this subject again\n";
		print "as soon as the outstanding update request has been\n";
		print "processed by the maintainer. Since openfaq\n";
		print "maintainers are volunteers, this may take time.\n";
		print "Thanks for your patience!\n";
		return;
	}
	print "<h2>Update an OpenFAQ Entry</h2>\n";
	$escaped = &htmlEscape($entry);
	&addBlurb;
print <<EOM
	<form action="$url/authors/edit.cgi/updatesubmit" method=POST>	
	<input name="id" type="hidden" value="$id">
	<input name="subject" value="$subject"> Subject
	Text: <br>
	<textarea rows="10" cols="60" name="entry">
	$escaped
	</textarea>
	<p>
	<input type="submit" value="Submit Entry"><input type="reset">
	</form>
EOM
;
}


sub addSubmit
{
	$id = &new;
	&updateSubmit;
}

sub balkUpdate
{
	if (open(IN, $id . ".update")) {
		close(IN);
		print "<h1>Another Request has Arrived</h1>\n";
		print "<strong>Whoops!</strong> Another request to update ",
			"or remove this article ",
			"arrived before yours. To avoid conflicts your ",
			"request will not be processed at this time. ",
			"Please wait for the maintainer to act on the ",
			"outstanding request. You can use the Back ",
			"button and copy the HTML text you have written ",
			"with the mouse in order to paste it into your ",
			"text editor for later use. Sorry for the ",
			"inconvenience.\n";
		return 1;
	}	
	return 0;
}

sub updateSubmit
{
	if (&balkUpdate) {
		return;
	}
	if ($input{"subject"} eq "") {
		print "<h2>Subject field missing</h2>\n";
		print "Please fill out all of the fields.\n";
		return;
	} elsif ($input{"entry"} eq "") {
		print "<h2>No text provided</h2>\n";
		print "Please fill out all of the fields.\n"; 
		return;
	} else {
		print "<h1>Thanks for your submission</h1>\n";
		&readEntry($id, 0);
		$subject = $input{"subject"};
		print "Your submission will look like this. If this is\n";
		print "correct, click on the accept button. If this is\n";
		print "not correct, make appropriate changes before\n";
		print "clicking on the accept button.\n";
		print "<h2>" . $subject . "</h2>\n";
		print "Contributors: ";
		print "<ul>\n";
		push @by, $user;
		push @email, $email;
		for ($i = 0; ($i < @by); $i++) {
			print "<li>", $by[$i], " <a href=\"mailto:", 
				$email[$i], "\">", $email[$i], "</a>\n"; 
		}
		print "</ul>\n";
		print "<hr>\n";
		print $input{"entry"};
		print "<hr>\n";
		print "<form action=\"", $url, "/authors/edit.cgi/updateconfirm\" method=POST>\n";
		print "<input name=\"subject\" value=\"", &htmlEscape($subject),
			"\"> Subject<br>";
		print "<input type=hidden name=\"id\" value=\"$id\">";
		print "<textarea name=\"entry\" cols=60 rows=10>\n";
		print &htmlEscape($input{"entry"});
		print "</textarea>\n";
		print "<br>\n";
		print "<input type=\"submit\" value=\"Accept\"> ";
		print "<input type=\"reset\" value=\"Reset\"> ";
		print "</form>\n";
		print "<br>\n";
	}
}

sub updateConfirm
{
	if (&balkUpdate) {
		return;
	}
	if ($input{"subject"} eq "") {
		print "<h2>Subject field missing</h2>\n";
		print "Please fill out all of the fields.\n";
		return;
	} elsif ($input{"entry"} eq "") {
		print "<h2>No text provided</h2>\n";
		print "Please fill out all of the fields.\n"; 
		return;
	} else {
		print "<h1>Thanks for your submission</h1>\n";
		print "<strong>Your submission will now be reviewed ",
			"by the moderator before it appears in the ",
			"OpenFAQ.</strong><p>";
		print "For your convenience in writing additional ",
			"articles before that time, the ID of the ",
			"article is: <strong>$id</strong><p>\n";
		print "Thanks for your contribution to ",
			"this volunteer effort!\n";		
		&readEntry($id, 0);
		push @by, $user;
		push @email, $email;
		$subject = $input{"subject"};
		$entry = $input{"entry"};
		&writeEntry($id, 1);
	}
}

sub removeSubmit
{
	if (&balkUpdate) {
		return;
	}
	print "<h1>Thanks for your contribution</h1>\n";
	print "<strong>Your removal request will now be reviewed ",
		"by the moderator before it takes effect.</strong><p>\n";
	print "Thanks for your contribution to ",
		"this volunteer effort!\n";		
	&readEntry($id, 0);
	push @by, $user;
	push @email, $email;
	# A simple flag
	$entry = "REMOVE REMOVE REMOVE";
	&writeEntry($id, 1);
}

sub addBlurb
{
	print <<EOM
	<h3>All entries are reviewed by the maintainer <strong>BEFORE</strong>
	they appear. If you are about to spam, don't bother.</h3>
	<strong>Yes,</strong> your entry can mention your product, but only
	if it is <strong>100% relevant to the subject. Marketing
	blurbs and press releases will be rejected. Hype adjectives
	such as "cyber" are frowned upon.</strong> 
	Thanks for your understanding.
	<p>	
	<strong>Entries should be written in HTML. The following
	tags and no others are permitted:</strong>
	<code>&lt;P&gt;, &lt;A&gt;...&lt;/A&gt;, 	
	&lt;CODE&gt;...&lt;/CODE&gt;, &lt;h3&gt;...&lt;/h3&gt;, 
	&lt;h4&gt;...&lt;/h4&gt;, and &lt;PRE&gt;...&lt;/PRE&gt;</code>.
	The use of any other tags may cause your submission to be rejected.
	<p>
	<strong>If you are not familiar with HTML syntax, please 
	refer to a good HTML tutorial first.</strong>
	<p>
	Thank you for your cooperation!
	<p>
	To make links to other articles, do this:
	<p>
	&lt;A HREF="ID.html"&gt;More Information about Cheese&lt;/a&gt;
	<p>
	Where ID should be replaced with the ID number shown to the
	right of the article in the table of contents. <em>ID numbers
	don't change.</em>
EOM
;
}

sub new
{
	# This is pretty quick. A collision is unlikely. Locking
	# calls can be added later.
	my($id);
	open(IN, "nextid.dat");
	$id = <IN>;
	$id = int($id) + 1;	
	close(IN);
	open(OUT, ">nextid.dat");
	print OUT $id, "\n";
	close(OUT);
	return $id;
}

