#!/usr/bin/perl5

require "../openfaq.pl";

&checkMaintainer;

opendir(DIN, ".");
@allfilesRaw = grep /^\d+$/, readdir DIN;
closedir(DIN);
@allfiles = sort { $a <=> $b } @allfilesRaw;
print STDERR "Sorted\n";
open(OUT, ">../index.html");
print OUT <<EOM
<html>
<head>
<title>$topic</title>
</head>
<body>
<h1>$topic</h1>
<h2>Maintainer: $maintainer, $maintainerEmail</h2>
This document is covered by the GNU Public License. All articles
can be freely reproduced intact under the terms of that license. 
Anyone can <a href="apply.cgi">become a contributor to this document!</a> 
<p>
<form action="authors/edit.cgi" method=POST>
<h3>Table of Contents</h3>
<dl>
EOM
;

for ($i = 0; ($i < int(@allfiles)); $i++) {
	$f = $allfiles[$i];
	$id = int($f);
	if ($i < (int(@allfiles) - 1)) {
		$next = int($allfiles[$i + 1]);
	}
	&readEntry($id, 0);
	$esc = &htmlEscape($subject);
	print OUT <<EOM
<dt><input type=radio name=id value=$id>
<a href="$id.html">$esc (ID: $id)</a>
EOM
;
	open(AOUT, ">../" . $id . ".html");
	print AOUT "<title>$topic</title>\n";
	print AOUT "<h1>$topic</h1>\n";
	print AOUT "<h2>$subject</h3>\n";
	print AOUT "<strong>Contributors:</strong><br>\n";
	print AOUT "<ul>\n";
	for ($j = 0; ($j < @by); $j++) {
		print AOUT "<li>", $by[$j], " <a href=\"mailto:",
			$email[$j], "\">", $email[$j], "</a>\n";
	}
	print AOUT "</ul>\n";
	print AOUT "<hr>\n";
	print AOUT $entry, "\n";
	print AOUT "<hr>\n";
	if ($i > 0) {
		print AOUT "<a href=\"$url/$prev.html\">Previous</a> | ";
	}
	if ($i < (int(@allfiles) - 1)) {
		print AOUT "<a href=\"$url/$next.html\">Next</a> | ";
	}
	print AOUT "<a href=\"$url\">Table of Contents</a>\n";
	close(AOUT);				
	$prev = $f;	
}

print OUT <<EOM	
</dl>
<hr>
<div align=center>
<em>For <a href="apply.cgi">Authors</a> Only</em><p>
<input type=submit name=add value="Add Article">
<input type=submit name=update value="Update Article">
<input type=submit name=remove value="Remove Article">
</div>
</form>
</body>
</html>
EOM
;
close(OUT);

opendir(DIN, ".");
@allfilesRaw = grep /^\d+$/, readdir DIN;
closedir(DIN);
@allfiles = sort { $a <=> $b } @allfilesRaw;
open(OUT, ">../toc.txt");
print OUT <<EOM
$topic

Maintainer: $maintainer, $maintainerEmail

This document is covered by the GNU Public License. All articles
can be freely reproduced intact under the terms of that license. 
Anyone can become a contributor to this document!

For the ANSWERS to these questions or to CONTRIBUTE NEW QUESTIONS
WITH ANSWERS, PLEASE VISIT:

http://www.boutell.com/openfaq/browsers/

Table of Contents

EOM
;

for ($i = 0; ($i < int(@allfiles)); $i++) {
	$f = $allfiles[$i];
	$id = int($f);
	if ($i < (int(@allfiles) - 1)) {
		$next = int($allfiles[$i + 1]);
	}
	&readEntry($id, 0);
	print OUT $subject;
}

print OUT <<EOM	

For the ANSWERS to these questions or to CONTRIBUTE NEW QUESTIONS
WITH ANSWERS, PLEASE VISIT:

http://www.boutell.com/openfaq/browsers/
EOM
;
close(OUT);

print <<EOM
<h1>TOC Updated</h1>
The table of contents file, toc.txt, has been updated. index.html
has also been updated.
EOM
;

print "<h2>Update Complete.</h2>\n";
print "Remember, you are going to have to hit reload ",
	"after going to the table of contents before you ",
	"will see any changes.\n";
print "<hr><a href=\"", $url, "\">To Table of Contents</a>\n";

